mod error;
mod graph;
mod state;
mod types;
mod vn;

pub mod ast;
pub mod parser;
pub mod spell;

pub mod prelude {
    // Types prefixed by crate name.
    pub use crate::{
        ast::{
            Const as GrimoireConstant, Expression as GrimoireExpression,
            VarOrConst as GrimoireVarOrConst,
        },
        error::Error as GrimoireError,
        graph::Graph as GrimoireGraph,
        state::State as GrimoireState,
        types::Type as GrimoireType,
    };

    // The VN structs.
    pub mod vn {
        pub use crate::vn::ConstOrVnType;
    }

    // Spell structs + standard spells re-rexports.
    pub mod spell {
        pub use crate::spell::{SpellArguments as Arguments, SpellFactory as Factory, std::*};
    }

    // Traits.
    pub use crate::{
        spell::{BuildableSpell as GrimoireBuildableSpell, Spell as GrimoireSpell},
        vn::{Actor as GrimoireActor, Printer as GrimoirePrinter},
    };
}
