pub const TRUE: &str = "true";
pub const FALSE: &str = "false";

pub fn check(keyword: &str) -> Result<&str, &'static str> {
    const RESERVED: &[&str] = &[TRUE, FALSE];
    const _: () = {
        let mut i = 0usize;
        while i < RESERVED.len() {
            let mut j = 0usize;
            let reserved = RESERVED[i].as_bytes();
            while j < reserved.len() {
                assert!(
                    u8::is_ascii_lowercase(&reserved[j]),
                    "reserved keyword must be ascii-lowercase composed..."
                );
                j += 1;
            }
            i += 1;
        }
    };

    match RESERVED.iter().find(|&&r| r == keyword.trim()) {
        Some(&reserved) => Err(reserved),
        None => Ok(keyword),
    }
}
