/// The struct to #[command(flatten)] inside the cli's arguments.
#[derive(clap::Args, Debug, Clone, Copy, Default)]
#[command(about = None, long_about = None)]
pub struct ColorChoice {
    #[arg( long
         , global          = true
         , default_value_t = clap::ColorChoice::Auto
         , value_name      = "WHEN"
         , value_enum
    )]
    /// Chose whever to display using colors or not
    color: clap::ColorChoice,
}

impl ColorChoice {
    pub fn into_inner(self) -> clap::ColorChoice {
        self.into()
    }
}

impl From<ColorChoice> for clap::ColorChoice {
    fn from(value: ColorChoice) -> Self {
        value.color
    }
}
